diff --git a/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/update/TableCreator.java b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/update/TableCreator.java
index 2a9f1aebde..2e3505e56b 100644
--- a/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/update/TableCreator.java
+++ b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/update/TableCreator.java
@@ -17,29 +17,31 @@ import java.util.List;
 import org.apache.commons.lang.StringUtils;
 import org.apache.log4j.Logger;
 
+import eu.etaxonomy.cdm.common.CdmUtils;
 import eu.etaxonomy.cdm.common.monitor.IProgressMonitor;
 import eu.etaxonomy.cdm.database.DatabaseTypeEnum;
 import eu.etaxonomy.cdm.database.ICdmDataSource;
+import eu.etaxonomy.cdm.model.agent.AgentBase;
 
 /**
  * @author a.mueller
  * @date 16.09.2010
  *
  */
-public class TableCreator extends SchemaUpdaterStepBase<TableCreator> implements ISchemaUpdaterStep {
+public class TableCreator extends AuditedSchemaUpdaterStepBase<TableCreator> implements ISchemaUpdaterStep {
 	private static final Logger logger = Logger.getLogger(TableCreator.class);
 	
 	private static final boolean SORT_INDEX = true;
 	
-	protected String tableName;
 	private List<String> columnNames;
 	private List<String> columnTypes;
 	private List<Object> defaultValues;
 	private List<Boolean> isNotNull;
 	private List<String> referencedTables;
-	private boolean includeAudTable;
 	private boolean includeCdmBaseAttributes;
 	private boolean includeIdentifiableEntity;
+	private boolean includeAnnotatableEntity;
+	private boolean includeEventBase;
 	protected List<ColumnAdder> columnAdders = new ArrayList<ColumnAdder>();
 	protected List<ISchemaUpdaterStep> mnTablesStepList = new ArrayList<ISchemaUpdaterStep>();
 	private String primaryKeyParams;
@@ -50,18 +52,29 @@ public class TableCreator extends SchemaUpdaterStepBase<TableCreator> implements
 	
 //	public static final TableCreator NewInstance(String stepName, String tableName, List<String> columnNames, List<String> columnTypes, List<Object> defaultValues, List<Boolean> isNull, boolean includeAudTable){
 	public static final TableCreator NewInstance(String stepName, String tableName, List<String> columnNames, List<String> columnTypes, boolean includeAudTable, boolean includeCdmBaseAttributes){
-		return new TableCreator(stepName, tableName, columnNames, columnTypes, null, null, null, includeAudTable, includeCdmBaseAttributes, false);
+		return new TableCreator(stepName, tableName, columnNames, columnTypes, null, null, null, includeAudTable, includeCdmBaseAttributes, false, false);
 	}
 	
 	public static final TableCreator NewInstance(String stepName, String tableName, String[] columnNames, String[] columnTypes, String[] referencedTables, boolean includeAudTable, boolean includeCdmBaseAttributes){
-		return new TableCreator(stepName, tableName, Arrays.asList(columnNames), Arrays.asList(columnTypes), null, null, Arrays.asList(referencedTables), includeAudTable, includeCdmBaseAttributes, false);
+		return new TableCreator(stepName, tableName, Arrays.asList(columnNames), Arrays.asList(columnTypes), null, null, Arrays.asList(referencedTables), includeAudTable, includeCdmBaseAttributes, false, false);
+	}
+	
+	public static final TableCreator NewAnnotatableInstance(String stepName, String tableName, String[] columnNames, String[] columnTypes, String[] referencedTables, boolean includeAudTable){
+		return new TableCreator(stepName, tableName, Arrays.asList(columnNames), Arrays.asList(columnTypes), null, null, Arrays.asList(referencedTables), includeAudTable, true, true, false);
+	}
+	
+	public static final TableCreator NewEventInstance(String stepName, String tableName, String[] columnNames, String[] columnTypes, String[] referencedTables, boolean includeAudTable){
+		TableCreator result = new TableCreator(stepName, tableName, Arrays.asList(columnNames), Arrays.asList(columnTypes), null, null, Arrays.asList(referencedTables), includeAudTable, true, true, false);
+		result.includeEventBase = true;
+		return result;
 	}
 	
 	public static final TableCreator NewIdentifiableInstance(String stepName, String tableName, String[] columnNames, String[] columnTypes, String[] referencedTables, boolean includeAudTable){
-		return new TableCreator(stepName, tableName, Arrays.asList(columnNames), Arrays.asList(columnTypes), null, null, Arrays.asList(referencedTables), includeAudTable, true, true);
+		return new TableCreator(stepName, tableName, Arrays.asList(columnNames), Arrays.asList(columnTypes), null, null, Arrays.asList(referencedTables), includeAudTable, true, true, true);
 	}
 	
-	protected TableCreator(String stepName, String tableName, List<String> columnNames, List<String> columnTypes, List<Object> defaultValues, List<Boolean> isNotNull, List<String> referencedTables, boolean includeAudTable, boolean includeCdmBaseAttributes, boolean includeIdentifiableEntity) {
+	protected TableCreator(String stepName, String tableName, List<String> columnNames, List<String> columnTypes, List<Object> defaultValues, List<Boolean> isNotNull, List<String> referencedTables, 
+			boolean includeAudTable, boolean includeCdmBaseAttributes, boolean includeAnnotatableEntity, boolean includeIdentifiableEntity) {
 		super(stepName);
 		this.tableName = tableName;
 		this.columnNames = columnNames;
@@ -71,12 +84,21 @@ public class TableCreator extends SchemaUpdaterStepBase<TableCreator> implements
 		this.referencedTables = referencedTables;
 		this.includeAudTable = includeAudTable;
 		this.includeCdmBaseAttributes = includeCdmBaseAttributes;
+		this.includeAnnotatableEntity = includeAnnotatableEntity;
 		this.includeIdentifiableEntity = includeIdentifiableEntity;
 		makeColumnAdders();
 		makeMnTables();
 	}
 
 
+	@Override
+	public List<ISchemaUpdaterStep> getInnerSteps() {
+		return mnTablesStepList;
+	}
+
+	/**
+	 * Fills the {@link #columnAdders} list.
+	 */
 	private void makeColumnAdders() {
 		if (columnNames.size() != columnTypes.size()){
 			throw new RuntimeException ("ColumnNames and columnTypes must be of same size. Step: " + getStepName());
@@ -89,7 +111,8 @@ public class TableCreator extends SchemaUpdaterStepBase<TableCreator> implements
 				ColumnAdder adder = ColumnAdder.NewIntegerInstance(this.getStepName(), this.tableName, this.columnNames.get(i), includeAudTable, isNotNull, referencedTable);
 				this.columnAdders.add(adder);
 			}else if ("boolean".equals(columnTypes.get(i)) || "bit".equals(columnTypes.get(i))){
-				ColumnAdder adder = ColumnAdder.NewBooleanInstance(getStepName(), this.tableName,  this.columnNames.get(i), includeAudTable, Boolean.valueOf(this.defaultValues.get(i).toString()));
+				String defaultValue = this.defaultValues == null ? null : this.defaultValues.get(i).toString();
+				ColumnAdder adder = ColumnAdder.NewBooleanInstance(getStepName(), this.tableName,  this.columnNames.get(i), includeAudTable, Boolean.valueOf(defaultValue));
 				this.columnAdders.add(adder);
 			}else if (columnTypes.get(i).startsWith("string")){
 				Integer length = Integer.valueOf(columnTypes.get(i).substring("string_".length()));
@@ -98,101 +121,36 @@ public class TableCreator extends SchemaUpdaterStepBase<TableCreator> implements
 			}else if ("tinyint".equals(columnTypes.get(i)) ){
 				ColumnAdder adder = ColumnAdder.NewTinyIntegerInstance(this.getStepName(), this.tableName, this.columnNames.get(i), includeAudTable, isNotNull);
 				this.columnAdders.add(adder);
+			}else if ("double".equals(columnTypes.get(i)) ){
+				ColumnAdder adder = ColumnAdder.NewDoubleInstance(this.getStepName(), this.tableName, this.columnNames.get(i), includeAudTable, isNotNull);
+				this.columnAdders.add(adder);
 			}
 		}
 	}
-
 	
-	/* (non-Javadoc)
-	 * @see eu.etaxonomy.cdm.database.update.SchemaUpdaterStepBase#invoke(eu.etaxonomy.cdm.database.ICdmDataSource, eu.etaxonomy.cdm.common.IProgressMonitor)
+	/**
+	 * fills the mnTablesStepList
 	 */
-	@Override
-	public Integer invoke(ICdmDataSource datasource, IProgressMonitor monitor) throws SQLException {
-		try {
-			boolean result = true;
-			result &= createTable(tableName, false, datasource, monitor);
-			if (includeAudTable){
-				String aud = "_AUD";
-				result &= createTable(tableName + aud, true, datasource, monitor);
-			}
-//			result &= invokeMns();
-			return (result == true )? 0 : null;
-		} catch (DatabaseTypeNotSupportedException e) {
-			throw new SQLException(e);
-		}
-	}
-
-
-
-	@Override
-	public List<ISchemaUpdaterStep> getInnerSteps() {
-		return mnTablesStepList;
-	}
-
-	private String getColumnsSql(String tableName, ICdmDataSource datasource, IProgressMonitor monitor) throws DatabaseTypeNotSupportedException {
-		String result = "";
-		for (ColumnAdder adder : this.columnAdders){
-			String singleAdderSQL = adder.getUpdateQueryString(tableName, datasource, monitor) + ", ";
-			
-			String[] split = singleAdderSQL.split(ColumnAdder.getAddColumnSeperator(datasource));
-			result += split[1];
-		}
-		return result;
-	}
-
-	private boolean createTable(String tableName, boolean isAudit, ICdmDataSource datasource, IProgressMonitor monitor) throws DatabaseTypeNotSupportedException {
-		boolean result = true;
-		String updateQuery = "CREATE TABLE @tableName (";
-		if (isAudit){
-			updateQuery += " REV integer not null, revtype tinyint, ";
-		}
-		if (includeCdmBaseAttributes){
-				updateQuery += " id integer not null,"
-					+ " created datetime, "
-					+ " uuid varchar(36),"
-					+ " updated datetime, "
-					+ " createdby_id integer,"
-					+ " updatedby_id integer, ";
-				
-		}
-		if (this.includeIdentifiableEntity){
-			updateQuery += "lsid_authority varchar(255), lsid_lsid varchar(255), lsid_namespace varchar(255), lsid_object varchar(255), lsid_revision varchar(255), protectedtitlecache bit not null, titleCache varchar(255),";
-		}
-		
-		updateQuery += 	getColumnsSql(tableName, datasource, monitor);
-		
-		String primaryKeySql = primaryKey(isAudit)==null ? "" : "primary key (" + primaryKey(isAudit) + "),";
-		String uniqueSql = unique(isAudit)== null ? "" : "unique(" + unique(isAudit) + "),";
-		updateQuery += primaryKeySql + uniqueSql;
-		
-		updateQuery = StringUtils.chomp(updateQuery.trim(), ",");
-		updateQuery += ")";
-		
-		updateQuery = updateQuery.replace("@tableName", tableName);
-		if (datasource.getDatabaseType().equals(DatabaseTypeEnum.MySQL)){
-			updateQuery += " ENGINE=MYISAM DEFAULT CHARSET=utf8 ";
-		}
-		logger.debug(updateQuery);
-		try {
-			datasource.executeUpdate(updateQuery);
-		} catch (SQLException e) {
-			logger.error(e);
-			result = false;
-		}
-		result &= createForeignKeys(tableName, isAudit, datasource, monitor);
-		return result;
-	}
-
-
 	private void makeMnTables() {
-		if (this.includeIdentifiableEntity){
-			TableCreator tableCreator;
+		TableCreator tableCreator;
+
+		if (this.includeAnnotatableEntity){
 			//annotations
 			stepName= "Add @tableName annotations";
 			stepName = stepName.replace("@tableName", this.tableName);
 			tableCreator = MnTableCreator.NewMnInstance(stepName, this.tableName, "Annotation", SchemaUpdaterBase.INCLUDE_AUDIT);
 			mnTablesStepList.add(tableCreator);
 
+			//marker
+			stepName= "Add @tableName marker";
+			stepName = stepName.replace("@tableName", this.tableName);
+			tableCreator = MnTableCreator.NewMnInstance(stepName, this.tableName, "Marker", SchemaUpdaterBase.INCLUDE_AUDIT);
+			mnTablesStepList.add(tableCreator);
+			
+		}
+		
+		if (this.includeIdentifiableEntity){
+
 			//credits
 			stepName= "Add @tableName credits";
 			stepName = stepName.replace("@tableName", this.tableName);
@@ -204,12 +162,6 @@ public class TableCreator extends SchemaUpdaterStepBase<TableCreator> implements
 			stepName = stepName.replace("@tableName", this.tableName);
 			tableCreator = MnTableCreator.NewMnInstance(stepName, this.tableName, "Extension", SchemaUpdaterBase.INCLUDE_AUDIT);
 			mnTablesStepList.add(tableCreator);
-
-			//marker
-			stepName= "Add @tableName marker";
-			stepName = stepName.replace("@tableName", this.tableName);
-			tableCreator = MnTableCreator.NewMnInstance(stepName, this.tableName, "Marker", SchemaUpdaterBase.INCLUDE_AUDIT);
-			mnTablesStepList.add(tableCreator);
 			
 			//OriginalSourceBase
 			stepName= "Add @tableName sources";
@@ -222,63 +174,209 @@ public class TableCreator extends SchemaUpdaterStepBase<TableCreator> implements
 			stepName = stepName.replace("@tableName", this.tableName);
 			tableCreator = MnTableCreator.NewMnInstance(stepName, this.tableName, "Rights", SchemaUpdaterBase.INCLUDE_AUDIT);
 			mnTablesStepList.add(tableCreator);
+		}
+	}
+
+
+	@Override
+	protected boolean invokeOnTable(String tableName, ICdmDataSource datasource, IProgressMonitor monitor)  {
+		try {
+			boolean result = true;
+			//CREATE
+			String updateQuery = "CREATE TABLE @tableName (";
+			//AUDIT
+			if (isAuditing){
+				updateQuery += " REV integer not null, revtype tinyint, ";
+			}
+			//CdmBase
+			if (includeCdmBaseAttributes){
+					updateQuery += " id integer not null,"
+						+ " created datetime, "
+						+ " uuid varchar(36),"
+						+ " updated datetime, "
+						+ " createdby_id integer,"
+						+ " updatedby_id integer, ";
+			}
+			//EventBase
+			if (this.includeEventBase){
+				updateQuery += "timeperiod_start varchar(255), timeperiod_end varchar(255), timeperiod_freetext varchar(255), actor_id int, description varchar(255),";
+			}
+			//Identifiable
+			if (this.includeIdentifiableEntity){
+				updateQuery += "lsid_authority varchar(255), lsid_lsid varchar(255), lsid_namespace varchar(255), lsid_object varchar(255), lsid_revision varchar(255), protectedtitlecache bit not null, titleCache varchar(255),";
+			}
+			//specific columns
+			updateQuery += 	getColumnsSql(tableName, datasource, monitor);
+			
+			//primary and unique keys
+			String primaryKeySql = primaryKey(isAuditing)==null ? "" : "primary key (" + primaryKey(isAuditing) + "),";
+			String uniqueSql = unique(isAuditing)== null ? "" : "unique(" + unique(isAuditing) + "),";
+			updateQuery += primaryKeySql + uniqueSql;
+			
+			//finalize
+			updateQuery = StringUtils.chomp(updateQuery.trim(), ",") + ")";
+			
+			//replace
+			updateQuery = updateQuery.replace("@tableName", tableName);
+			
+			//append datasource specific string
+			updateQuery += datasource.getDatabaseType().getHibernateDialect().getTableTypeString();
+			logger.debug("UPDATE Query: " + updateQuery);
+			
+			//execute
+			datasource.executeUpdate(updateQuery);
+			
+			//Foreign Keys
+			result &= createForeignKeys(tableName, isAuditing, datasource, monitor);
+			
+			return result;
+		} catch (Exception e) {
+			monitor.warning(e.getMessage(), e);
+			logger.error(e);
+			return false;
+		}
+	}
 
+
+	/**
+	 * Returns the sql part for the {@link #columnAdders} columns.
+	 * This is done by reusing the same method in the ColumnAdder class and removing all the prefixes like 'ADD COLUMN'
+	 */
+	private String getColumnsSql(String tableName, ICdmDataSource datasource, IProgressMonitor monitor) throws DatabaseTypeNotSupportedException {
+		String result = "";
+		for (ColumnAdder adder : this.columnAdders){
+			String singleAdderSQL = adder.getUpdateQueryString(tableName, datasource, monitor) + ", ";
 			
+			String[] split = singleAdderSQL.split(ColumnAdder.getAddColumnSeperator(datasource));
+			result += split[1];
 		}
+		return result;
 	}
+
 	
-	private boolean createForeignKeys(String tableName, boolean isAudit, ICdmDataSource datasource, IProgressMonitor monitor) {
+	private boolean createForeignKeys(String tableName, boolean isAudit, ICdmDataSource datasource, IProgressMonitor monitor) throws SQLException {
 		boolean result = true;
 		if (includeCdmBaseAttributes){
 			String attribute = "updatedby";
 			String referencedTable = "UserAccount";
-			result &= makeForeignKey(tableName, datasource, attribute, referencedTable);
+			result &= makeForeignKey(tableName, datasource, monitor, attribute, referencedTable);
 			
 			attribute = "createdby";
 			referencedTable = "UserAccount";
-			result &= makeForeignKey(tableName, datasource, attribute, referencedTable);			
+			result &= makeForeignKey(tableName, datasource, monitor, attribute, referencedTable);			
 		
 		}
 		if (isAudit){
 			String attribute = "REV";
 			String referencedTable = "AuditEvent";
-			result &= makeForeignKey(tableName, datasource, attribute, referencedTable);
+			result &= makeForeignKey(tableName, datasource, monitor, attribute, referencedTable);
+		}
+		if (this.includeEventBase){
+			String attribute = "actor_id";
+			String referencedTable = "AgentBase";
+			result &= makeForeignKey(tableName, datasource, monitor, attribute, referencedTable);
 		}
 		for (ColumnAdder adder : this.columnAdders){
 			if (adder.getReferencedTable() != null){
-				result &= makeForeignKey(tableName, datasource, adder.getNewColumnName(), adder.getReferencedTable()); 
+				result &= makeForeignKey(tableName, datasource, monitor, adder.getNewColumnName(), adder.getReferencedTable()); 
 			}
 		}
 		return result;
 	}
 
-	public static boolean makeForeignKey(String tableName, ICdmDataSource datasource, String attribute, String referencedTable) {
+	public static boolean makeForeignKey(String tableName, ICdmDataSource datasource, IProgressMonitor monitor, String attribute, String referencedTable) throws SQLException {
 		boolean result = true;
-		String index = "FK@tableName_@attribute";
-		index = index.replace("@tableName", tableName);
-		index = index.replace("@attribute", attribute);
 		
-		String idSuffix = "_id";
-		if ("REV".equalsIgnoreCase(attribute) || attribute.endsWith(idSuffix)){
-			idSuffix = "";
+		if (supportsForeignKeys(datasource, monitor, tableName, referencedTable)){
+			String index = "FK@tableName_@attribute";
+			index = index.replace("@tableName", tableName);
+			index = index.replace("@attribute", attribute);
+			
+			String idSuffix = "_id";
+			if (isRevAttribute(attribute) || attribute.endsWith(idSuffix)){
+				idSuffix = "";
+			}
+			String updateQuery = "ALTER TABLE @tableName ADD INDEX @index (@attribute), ADD CONSTRAINT @index FOREIGN KEY (@attribute) REFERENCES @referencedTable (@id)";
+			updateQuery = updateQuery.replace("@tableName", tableName);
+			updateQuery = updateQuery.replace("@index", index);
+			updateQuery = updateQuery.replace("@attribute", attribute + idSuffix);
+			updateQuery = updateQuery.replace("@referencedTable", referencedTable);
+			if (isRevAttribute(attribute)){
+				updateQuery = updateQuery.replace("@id", "revisionnumber");
+			}else{
+				updateQuery = updateQuery.replace("@id", "id");
+			}
+			logger.debug(updateQuery);
+			try {
+				datasource.executeUpdate(updateQuery);
+			} catch (Exception e) {
+				String message = "Problem when creating Foreign Key for " + tableName +"." + attribute +": " + e.getMessage();
+				monitor.warning(message);
+				logger.warn(message, e);
+				return true;
+			}
+			return result;			
+		}else{
+			return true;
 		}
-		String updateQuery = "ALTER TABLE @tableName ADD INDEX @index (@attribute), ADD CONSTRAINT @index FOREIGN KEY (@attribute) REFERENCES @referencedTable (id)";
-		updateQuery = updateQuery.replace("@tableName", tableName);
-		updateQuery = updateQuery.replace("@index", index);
-		updateQuery = updateQuery.replace("@attribute", attribute + idSuffix);
-		updateQuery = updateQuery.replace("@referencedTable", referencedTable);
-		
-		logger.debug(updateQuery);
-		try {
-			datasource.executeUpdate(updateQuery);
-		} catch (SQLException e) {
-			logger.error(e);
-			result = false;
+
+	}
+
+	/**
+	 * Determines if the tables and the database support foreign keys. If determination is not possible true is returned as default.
+	 * @param datasource
+	 * @param monitor
+	 * @param tableName
+	 * @param referencedTable
+	 * @return
+	 */
+	private static boolean supportsForeignKeys(ICdmDataSource datasource, IProgressMonitor monitor, String tableName, String referencedTable) {
+		boolean result = true;
+		if (! datasource.getDatabaseType().equals(DatabaseTypeEnum.MySQL)){
+			return true;
+		}else{
+			try {
+				String myIsamTables = "";
+				String format = "SELECT ENGINE FROM information_schema.TABLES where TABLE_SCHEMA = '%s' AND TABLE_NAME = '%s'";
+				String sql = String.format(format, datasource.getDatabase(), tableName);
+				String engine = (String)datasource.getSingleValue(sql);
+				if (engine.equals("MyISAM")){
+					result = false;
+					myIsamTables = CdmUtils.concat(",", myIsamTables, tableName);
+				}
+				sql = String.format(format,  datasource.getDatabase(), referencedTable);
+				engine = (String)datasource.getSingleValue(sql);
+				if (engine.equals("MyISAM")){
+					result = false;
+					myIsamTables = CdmUtils.concat(",", myIsamTables, referencedTable);
+				}
+				if (result == false){
+					String message = "Tables (%s) use MyISAM engine. MyISAM does not support foreign keys.";
+					message = String.format(message, myIsamTables);
+					monitor.warning(message);
+				}
+				return result;
+			} catch (Exception e) {
+				String message = "Problems to determine table engine for MySQL.";
+				monitor.warning(message);
+				return true;  //default 
+			}
+			
 		}
-		return result;
+		
+				
+	}
+
+	private static boolean isRevAttribute(String attribute) {
+		return "REV".equalsIgnoreCase(attribute);
 	}
 
 
+	/**
+	 * Constructs the primary key creation string
+	 * @param isAudit
+	 * @return
+	 */
 	protected String primaryKey(boolean isAudit){
 		String result = null;
 		if (! isAudit && this.primaryKeyParams != null){ 
@@ -297,6 +395,11 @@ public class TableCreator extends SchemaUpdaterStepBase<TableCreator> implements
 		return result;
 	}
 	
+	/**
+	 * Constructs the unique key creation string
+	 * @param isAudit
+	 * @return
+	 */
 	protected String unique(boolean isAudit){
 		if (! isAudit){
 			if (this.uniqueParams != null){
diff --git a/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/update/TableDroper.java b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/update/TableDroper.java
index d81281fffa..ece754b453 100644
--- a/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/update/TableDroper.java
+++ b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/update/TableDroper.java
@@ -9,8 +9,6 @@
 */
 package eu.etaxonomy.cdm.database.update;
 
-import java.sql.SQLException;
-
 import org.apache.log4j.Logger;
 
 import eu.etaxonomy.cdm.common.monitor.IProgressMonitor;
@@ -22,62 +20,75 @@ import eu.etaxonomy.cdm.database.ICdmDataSource;
  * @date 16.09.2010
  *
  */
-public class TableDroper extends SchemaUpdaterStepBase<TableDroper> implements ISchemaUpdaterStep {
-	@SuppressWarnings("unused")
+public class TableDroper extends AuditedSchemaUpdaterStepBase<TableDroper> implements ISchemaUpdaterStep {
 	private static final Logger logger = Logger.getLogger(TableDroper.class);
 	
-	private String tableName;
-		private boolean includeAudTable;
+	private boolean ifExists = true;
 	
 	public static final TableDroper NewInstance(String stepName, String tableName, boolean includeAudTable){
-		return new TableDroper(stepName, tableName, includeAudTable);
+		return new TableDroper(stepName, tableName, includeAudTable, true);
+	}
+	
+	/**
+	 * @param stepName
+	 * @param tableName
+	 * @param includeAudTable
+	 * @param ifExists if false, and error will be thrown if the table does not exist and can therefore not be dropped.
+	 * @see #NewInstance(String, String, boolean)
+	 * @return
+	 */
+	public static final TableDroper NewInstance(String stepName, String tableName, boolean includeAudTable, boolean ifExists){
+		return new TableDroper(stepName, tableName, includeAudTable, ifExists);
 	}
 
 	
-	protected TableDroper(String stepName, String tableName, boolean includeAudTable) {
+	protected TableDroper(String stepName, String tableName, boolean includeAudTable, boolean ifExists) {
 		super(stepName);
 		this.tableName = tableName;
 		this.includeAudTable = includeAudTable;
+		this.ifExists = ifExists;
 	}
 
-	/* (non-Javadoc)
-	 * @see eu.etaxonomy.cdm.database.update.SchemaUpdaterStepBase#invoke(eu.etaxonomy.cdm.database.ICdmDataSource, eu.etaxonomy.cdm.common.IProgressMonitor)
-	 */
 	@Override
-	public Integer invoke(ICdmDataSource datasource, IProgressMonitor monitor) throws SQLException {
-		boolean result = true;
-		result &= removeTable(tableName, datasource, monitor);
-		if (includeAudTable){
-			String aud = "_AUD";
-			result &= removeTable(tableName + aud, datasource, monitor);
-		}
-		return (result == true )? 0 : null;
-	}
-
-	private boolean removeTable(String tableName, ICdmDataSource datasource, IProgressMonitor monitor) {
+	protected boolean invokeOnTable(String tableName, ICdmDataSource datasource, IProgressMonitor monitor) {
 		boolean result = true;
 		try {
 			String updateQuery = getUpdateQueryString(tableName, datasource, monitor);
-			try {
-				datasource.executeUpdate(updateQuery);
-			} catch (SQLException e) {
-				logger.error(e);
-				result = false;
+			datasource.executeUpdate(updateQuery);
+			if (! this.isAuditing){
+				removeFromHibernateSequences(datasource, monitor, tableName);
 			}
 			return result;
-		} catch ( DatabaseTypeNotSupportedException e) {
+		} catch ( Exception e) {
+			monitor.warning(e.getMessage(), e);
+			logger.error(e);
 			return false;
 		}
 	}
 
+	private boolean removeFromHibernateSequences(ICdmDataSource datasource, IProgressMonitor monitor, String tableName) {
+		try {
+			String sql = " DELETE FROM hibernate_sequences WHERE sequence_name = '%s'";
+			sql = String.format(sql, tableName);
+			datasource.executeUpdate(sql);
+			return true;
+		} catch (Exception e) {
+			String message = "Exception occurred when trying to read or update hibernate_sequences table for value " + this.tableName + ": " + e.getMessage();
+			monitor.warning(message, e);
+			logger.error(message);
+			return false;
+		}
+		
+	}
+
 	public String getUpdateQueryString(String tableName, ICdmDataSource datasource, IProgressMonitor monitor) throws DatabaseTypeNotSupportedException {
 		String updateQuery;
 		DatabaseTypeEnum type = datasource.getDatabaseType();
 		
-		updateQuery = "DROP TABLE @tableName";
+		updateQuery = "DROP TABLE @ifExists @tableName ";
 		if (type.equals(DatabaseTypeEnum.SqlServer2005)){
 			//MySQL allows both syntaxes
-//			updateQuery = "ALTER TABLE @tableName ADD @columnName @columnType";
+			updateQuery = " if exists (select * from INFORMATION_SCHEMA.TABLES where TABLE_NAME='@tableName') BEGIN drop table @tableName end ";
 		}else if (type.equals(DatabaseTypeEnum.H2) || type.equals(DatabaseTypeEnum.PostgreSQL) || type.equals(DatabaseTypeEnum.MySQL)){
 //			updateQuery = "ALTER TABLE @tableName @addSeparator @columnName @columnType";
 		}else{
@@ -87,6 +98,11 @@ public class TableDroper extends SchemaUpdaterStepBase<TableDroper> implements I
 			throw new DatabaseTypeNotSupportedException(warning);
 		}
 		updateQuery = updateQuery.replace("@tableName", tableName);
+		if (ifExists == true){
+			updateQuery = updateQuery.replace("@ifExists", "IF EXISTS");
+		}else{
+			updateQuery = updateQuery.replace("@ifExists", "");
+		}
 		
 		return updateQuery;
 	}
diff --git a/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/update/TableNameChanger.java b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/update/TableNameChanger.java
index 05c6b3c009..a91839a7f8 100644
--- a/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/update/TableNameChanger.java
+++ b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/update/TableNameChanger.java
@@ -23,7 +23,6 @@ import eu.etaxonomy.cdm.database.ICdmDataSource;
  *
  */
 public class TableNameChanger extends SchemaUpdaterStepBase<TableNameChanger> implements ISchemaUpdaterStep {
-	@SuppressWarnings("unused")
 	private static final Logger logger = Logger.getLogger(TableNameChanger.class);
 	
 	private String oldName;
@@ -41,21 +40,20 @@ public class TableNameChanger extends SchemaUpdaterStepBase<TableNameChanger> im
 		this.includeAudTable = includeAudTable;
 	}
 
-	/* (non-Javadoc)
-	 * @see eu.etaxonomy.cdm.database.update.SchemaUpdaterStepBase#invoke(eu.etaxonomy.cdm.database.ICdmDataSource, eu.etaxonomy.cdm.common.IProgressMonitor)
-	 */
 	@Override
 	public Integer invoke(ICdmDataSource datasource, IProgressMonitor monitor) throws SQLException {
 		boolean result = true;
-		result &= renameTable(oldName, newName, datasource, monitor);
+		result &= invokeOnTable(oldName, newName, datasource, monitor);
+		updateHibernateSequence(datasource, monitor, newName, oldName); //no result&= as hibernateSequence problems may not lead to a complete fail
 		if (includeAudTable){
 			String aud = "_AUD";
-			result &= renameTable(oldName + aud, newName + aud, datasource, monitor);
+			result &= invokeOnTable(oldName + aud, newName + aud, datasource, monitor);
 		}
 		return (result == true )? 0 : null;
 	}
 
-	private boolean renameTable(String oldName, String newName, ICdmDataSource datasource, IProgressMonitor monitor) {
+	//does not support AuditedSchemaUpdaterStepBase signature
+	private boolean invokeOnTable(String oldName, String newName, ICdmDataSource datasource, IProgressMonitor monitor) {
 		DatabaseTypeEnum type = datasource.getDatabaseType();
 		String updateQuery;
 		if (type.equals(DatabaseTypeEnum.MySQL)){
@@ -73,11 +71,36 @@ public class TableNameChanger extends SchemaUpdaterStepBase<TableNameChanger> im
 		updateQuery = updateQuery.replace("@oldName", oldName);
 		updateQuery = updateQuery.replace("@newName", newName);
 		try {
-			datasource.executeQuery(updateQuery);
+			datasource.executeUpdate(updateQuery);
 		} catch (SQLException e) {
+			String message = "Could not perform rename table operation";
 			monitor.warning("Could not perform rename table operation", e);
+			logger.warn(message+ ": "  + e.getMessage());
+			return false;
 		}
 		return true;
 	}
 
+	/**
+	 * 
+	 * @param datasource
+	 * @param monitor
+	 * @param table
+	 * @param oldVal
+	 * @return
+	 */
+	private boolean updateHibernateSequence(ICdmDataSource datasource, IProgressMonitor monitor, String newName, String oldName){
+		try{
+			String sql = " UPDATE hibernate_sequences SET sequence_name = '%s' WHERE sequence_name = '%s'";	
+			datasource.executeUpdate(String.format(sql, newName ,oldName));
+			return true;
+		} catch (Exception e) {
+			String message = "Exception occurred when trying to read or update hibernate_sequences table for value " + this.newName + ": " + e.getMessage();
+			monitor.warning(message, e);
+			logger.error(message);
+			return false;
+		}
+		
+	}
+
 }
